-- require "./AI/Const.lua" 

 
--------------------------------------------
-- List utility 
--------------------------------------------
List = {}
	
function List.new () 
	return { first = 0, last = -1}
end

 
function List.pushleft (list, value) 
	local first = list.first-1
	list.first  = first
	list[first] = value;
end

 
function List.pushright (list, value) 
	local last = list.last + 1
	list.last = last
	list[last] = value
end

 
function List.popleft (list) 
	local first = list.first
	if first > list.last then
		return nil
	end
	local value = list[first]
	list[first] = nil         -- to allow garbage collection
	list.first = first+1
	return value
end

 
function List.popright (list) 
	local last = list.last
	if list.first > last then
		return nil
	end
	local value = list[last]
	list[last] = nil
	list.last = last-1
	return value
end

 
function List.clear (list) 
	for i,v in ipairs(list) do
		list[i] = nil
	end
--[[
	if List.size(list) == 0 then
		return
	end
	local first = list.first
	local last  = list.last
	for i=first, last do
		list[i] = nil
	end
--]]
	list.first = 0
	list.last = -1
end

 
function List.size (list) 
	local size = list.last - list.first + 1
	return size
end

-------------------------------------------------

  
function	GetDistance (x1,y1,x2,y2) 
	return math.floor(math.sqrt((x1-x2)^2+(y1-y2)^2))
end




 
function	GetDistance2 (id1, id2) 
	local x1, y1 = GetV (V_POSITION,id1)
	local x2, y2 = GetV (V_POSITION,id2)
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance (x1,y1,x2,y2)
end




 
function	GetOwnerPosition (id) 
	return GetV (V_POSITION,GetV(V_OWNER,id))
end





 
function	GetDistanceFromOwner (id) 
	local x1, y1 = GetOwnerPosition (id)
	local x2, y2 = GetV (V_POSITION,id)
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance (x1,y1,x2,y2)
end




 
function	GetDistanceFromMaster (myid) 
------------------------------------------
-- }X^[Ƃ̋vZ
------------------------------------------
	local x1, y1 = GetV (V_POSITION,MyMaster)
	local x2, y2 = GetV (V_POSITION,myid)
	if (x1 == -1 or x2 == -1) then
		return -1
	end
	return GetDistance (x1,y1,x2,y2)
end


 
function	IsOutOfSight (id1,id2) 
	local x1,y1 = GetV (V_POSITION,id1)
	local x2,y2 = GetV (V_POSITION,id2)
	if (x1 == -1 or x2 == -1) then
		return true
	end
	local d = GetDistance (x1,y1,x2,y2)
	if d > 20 then
		return true
	else
		return false
	end
end





 
function	IsInAttackSight (id1,id2) 
	local x1,y1 = GetV (V_POSITION,id1)
	local x2,y2 = GetV (V_POSITION,id2)
	if (x1 == -1 or x2 == -1) then
		return false
	end
	local d		= GetDistance (x1,y1,x2,y2)
	local a     = 0
--	if (MySkill == 0) then
		a     = GetV (V_ATTACKRANGE,id1)
--	else
--		a     = GetV (V_SKILLATTACKRANGE,id1,MySkill)
--	end

	if a >= d then
		return true;
	else
		return false;
	end
end

 
-- IsȂ񂿂֐ IuWFNgޔʌn --------------- 

	
function IsPlayer (id) 
------------------------------------------
-- ΏۂvC[f (true:vC[ false:̑)
-- zid < 100000 Ƃ񍐂BŃvC[ƃz𔻕ʁB
------------------------------------------
	local type = GetV(V_HOMUNTYPE,id)					-- id̃^Cv𒲂ׂB

	--[[
	if IsMonster(id) == 1 then		-- IsMonster ł܂͔fAPvPtB[hœGvC[ȂAvC[Ƃ݂ȂȂB
		return false
	else
	]]

	if (id < 100000 or id == -1) then	-- ID͈͂ŔfANPCAPETAzȂǂ͂B
		return false
	else
		return true
	end
end


 
function IsHom (id) 
------------------------------------------
-- ΏۂzNXf (True:z False:̑)
-- zid < 100000 Ƃ񍐂BŃvC[ƃz𔻕ʁB
------------------------------------------
	local type = GetV(V_HOMUNTYPE,id)					-- id̃^Cv𒲂ׂB
	if (0 <= type and type <= 16 and id < 100000) then
			return true
	end
	return false
end

 
function IsPet (id) 
------------------------------------------
-- Ώۂybgf (True:ybg False:̑)
--
-- ybǵAV_HOMUNTYPE̖߂l͕ʂMobƓAIsMonster  0 Ȃ̂Ń\`FbNB
-- (mob^NPCɂȗ\B)
------------------------------------------

	local type = GetV(V_HOMUNTYPE,id)					-- id̃^Cv𒲂ׂB
	if (1000 <= type and type <= 1700) then				-- G̏ꍇType1001`1700 Ȃ烂X^[FgpID܂܂邯ǋCɂȂB
		if (IsMonster(id) == 0) then					-- ʏmob𒲂ׂB
			return true
		end
	end
	return false
end






 
function IsPlant(id) 
------------------------------------------
-- ARMOB`FbN
------------------------------------------

-- zɂĂsŖRMob͊܂߂ĂȂI

	local target = GetV(V_HOMUNTYPE,id)					-- id̃^Cv𒲂ׂB

	if(target >= 1078 and target <= 1085) then
		return true										-- ^[Qbgor̂̏ꍇ
--	elseif(target == 1008 or target == 1047 or target == 1048 or target == 1097 or target == 1142) then
--		return true										-- ^[QbgRMOB̏ꍇ
	elseif(targer == 1589 or target == 1575 or target == 1579 or target == 1555 or target == 1590) then
		return true										-- ^[QbgoCIvg̏ꍇ
	end

	return false
end


  
